package Clases;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

import Principal.TecladoUtils;

@SuppressWarnings("unused")
public class Transicion {
	Estado origen;
	String frase;
	String[] accion;
	String listaTeclas;
	Estado destino;
	
	public Transicion(Estado origen, String frase, String[] accion, Estado destino) {
		super();
		this.origen = origen;
		this.frase = frase;
		this.accion = accion;
		this.listaTeclas = null;
		this.destino = destino;
	}
	
	public Transicion(Estado origen, String frase, String accion, Estado destino) {
		super();
		this.origen = origen;
		this.frase = frase;
		
		if(accion.length()>0){
			TecladoUtils u = new TecladoUtils();
			this.accion = u.crearTeclas(accion);
		}
		else this.accion=null;

		this.listaTeclas=accion;
		this.destino = destino;
	}
	
	public String juntar(String[] cads){
		String res = "";
		for (int i=0; i<cads.length; i++){
			if (cads[i].split(" ").length > 1){
				res = res + " '" + cads[i] + "'";
			}else{
				res = res + " " + cads[i];
			}		
		}
		return res.substring(1);
	}
	
	public void ejecutarAccion() throws InterruptedException{
		if (this.accion!=null){
			try {
				System.out.print("("+listaTeclas+")");
			
//				String s;
				Process p = Runtime.getRuntime().exec(accion);
//				 BufferedReader buffr = new BufferedReader(
//			                new InputStreamReader(p.getErrorStream()));
//				 while ((s = buffr.readLine()) != null)
//		             System.out.println("line: " + s);
		         p.waitFor();
		         //System.out.println ("exit: " + p.exitValue());
		         p.destroy();	         
		         
			} catch (IOException e) {
				System.out.println("***ERROR AL EJECUTAR LA ACCIÓN REQUERIDA***");
				e.printStackTrace();
				System.exit(1);
			}
		}
	}	
}
