package Gestores;

import Clases.Automata;
import Clases.Estado;
import Principal.TecladoUtils;

public class GestorNuevoMensaje {

	TecladoUtils u;
	
	public GestorNuevoMensaje(){
		u = new TecladoUtils();
	}

	public void rellenarNuevoMensaje(Automata aut){
		Estado o = aut.getEstadoNuevoMensaje();
		Estado e = new Estado("estadoEspera-Redactar");
		e.addTransicion("continuar","",o);
				
		Estado panelContactos = new Estado("panelContactos");
		// F9, Alt+U, Tab
		aut.addTransicion(o, "ver panel de contactos",
				"F9, Alt_L+U, Tab", panelContactos);
		rellenarPanelContactos(aut);
		
		aut.addTransicion(o, "guardar", "Control_L+S", e);
		aut.addTransicion(o, "guardar archivo", "Control_L+S", e);
		aut.addTransicion(o, "guardar borrador", "Alt_L+A,A,D", e);
		aut.addTransicion(o, "guardar plantilla", "Alt_L+A,A,T", e);

		
		/********************************/
		Estado menuArchivo = new Estado("nuevoMensaje-MenuArchivo");
		aut.addTransicion(o, "abrir menu archivo", "Alt_L+a",menuArchivo);
		aut.addTransicion(o, "menu archivo", "Alt_L+a",menuArchivo);
		
		Estado menuEditar = new Estado("nuevoMensaje-MenuEditar");
		aut.addTransicion(o, "abrir menu editar", "Alt_L+e",menuEditar);
		aut.addTransicion(o, "menu editar", "Alt_L+e",menuEditar);
		
		Estado menuVer = new Estado("nuevoMensaje-MenuVer");
		aut.addTransicion(o, "abrir menu ver", "Alt_L+v",menuVer);
		aut.addTransicion(o, "menu ver", "Alt_L+v",menuVer);
		
		Estado menuInsertar = new Estado("nuevoMensaje-MenuInsertar");
		aut.addTransicion(o, "abrir menu insertar", "Alt_L+i",menuInsertar);
		aut.addTransicion(o, "menu insertar", "Alt_L+i",menuInsertar);
		
		Estado menuFormato = new Estado("nuevoMensaje-MenuFormato");
		aut.addTransicion(o, "abrir menu formato", "Alt_L+o",menuFormato);
		aut.addTransicion(o, "menu formato", "Alt_L+o", menuFormato);

		Estado menuHerramientas = new Estado("nuevoMensaje-MenuHerramientas");
		aut.addTransicion(o, "abrir menu herramientas", "Alt_L+t",menuHerramientas);
		aut.addTransicion(o, "menu herramientas", "Alt_L+t", menuHerramientas);
		
		Estado menuOpciones = new Estado("nuevoMensaje-MenuOpciones");
		aut.addTransicion(o, "abrir menu opciones", "Alt_L+p",menuOpciones);
		aut.addTransicion(o, "menu opciones", "Alt_L+p", menuOpciones);
		
		Estado menuAyuda = new Estado("nuevoMensaje-MenuAyuda");
		aut.addTransicion(o, "abrir menu ayuda", "Alt_L+u",menuAyuda);
		aut.addTransicion(o, "menu ayuda", "Alt_L+u", menuAyuda);		
		
		rellenarMenuArchivo(aut);
		rellenarMenuEditar(aut);
		rellenarMenuVer(aut);
		rellenarMenuInsertar(aut);
		rellenarMenuFormato(aut);
		rellenarMenuOpciones(aut);
		rellenarMenuHerramientas(aut);
		rellenarMenuAyuda(aut);
		/********************************/		
		
		aut.addTransicion(o, "enviar mensaje", 
				"Control_L+Return", aut.getEstadoInicial());
		aut.addTransicion(o, "enviar ahora", 
				"Control_L+Return", aut.getEstadoInicial());
		aut.addTransicion(o, "enviar", 
				"Control_L+Return", aut.getEstadoInicial());
		aut.addTransicion(o, "enviar mas tarde", 
				"Control_L+Shift_L+Return", aut.getEstadoInicial());
		
		aut.addTransicion(o, "cerrar ventana", 
				"Alt_L+F4", aut.getEstadoInicial());
		aut.addTransicion(o, "cerrar", 
				"Alt_L+F4", aut.getEstadoInicial()); 

		aut.addTransicion(o, "adjuntar",
				"Alt_L+A, T, Right", aut.getEstadoByName("nuevoMensaje-MenuArchivo-Adjuntar"));
		
		aut.addTransicion(o, "adjuntar archivos",
				"Shift_L+Control_L+A", e);
		aut.addTransicion(o, "ortografia", "Shift_L+Control_L+P", e);
		// Alt+P, E
		aut.addTransicion(o, "cifrar mensaje", "Alt_L+P, E",e);
		// Alt+P, F
		aut.addTransicion(o, "firmar digitalmente este mensaje",
				"Alt_L+P, F, F, Return", e);
		// Alt+V, S
		aut.addTransicion(o, "ver informacion de seguridad",
				"Alt_L+V, S", e);
		// Alt+V, S
		aut.addTransicion(o, "seguridad",
				"Alt_L+V, S", e);		
		
		aut.addTransicion(o, "siguiente campo", "F6", o);
		aut.addTransicion(o, "anterior campo", "Shift_L+F6", o);

		aut.addTransicion(o, "campo de", "Alt_L+D", o);
		aut.addTransicion(o, "campo remitente", "Alt_L+D", o);
		aut.addTransicion(o, "campo destinatario", "Alt_L+D,Tab,Tab", o);
		aut.addTransicion(o, "campo asunto", "Alt_L+S", o);
		aut.addTransicion(o, "campo mensaje", "Alt_L+S,Tab", o);				
	}
	
	public void rellenarPanelContactos(Automata aut){
		Estado o = aut.getEstadoByName("panelContactos");
		
		aut.addTransicion(o, "siguiente contacto", "Down", o);
		aut.addTransicion(o, "anterior contacto", "Up", o);
		aut.addTransicion(o, "siguiente libreta de direcciones",
				"Alt_L+L, Down, Tab, Tab", o);
		aut.addTransicion(o, "anterior libreta de direcciones",
				"Alt_L+L, Up, Tab, Tab", o);
		
		// Devuelven el cursor a la lista de contactos
		
			// PARA
			aut.addTransicion(o, "a~nadir a para","Alt_L+A, Alt_L+U, Tab", o);
			
			//CC
			aut.addTransicion(o, "a~nadir a ce ce", "Alt_L+C, Alt_L+U, Tab", o);
			aut.addTransicion(o, "a~nadir a copia carbon", "Alt_L+C, Alt_L+U, Tab", o);
			
			// BCC
			aut.addTransicion(o, "a~nadir a be ce ce", "Alt_L+B,Alt_L+U,Tab", o);
			aut.addTransicion(o, "a~nadir a copia carbon oculta", "Alt_L+B,Alt_L+U,Tab", o);

		Estado espera = new Estado("estadoEspera-Panel");
		espera.addTransicion("continuar","Tab",o);
		aut.addTransicion(o, "buscar", "Alt_L+U",espera);
				
		aut.addTransicion(o, "cerrar panel de contactos", "Alt_L+D,F9", aut.getEstadoByName("nuevoMensaje"));
		aut.addTransicion(o, "cerrar",
				"Alt_L+D,F9", aut.getEstadoByName("nuevoMensaje"));
	}
	
	public void rellenarMenuArchivo(Automata aut){
		Estado o = aut.getEstadoByName("nuevoMensaje-MenuArchivo");
		Estado i = aut.getEstadoNuevoMensaje();
		Estado e = aut.getEstadoByName("estadoEspera-Redactar");		
		
		Estado nuevo = new Estado("nuevoMensaje-MenuArchivo-Nuevo");
		aut.addTransicion(o, "nuevo", "n", nuevo);
		rellenarMenuArchivoNuevo(aut);
		
		aut.addTransicion(o, "guardar", "g", e);
		
		Estado adjuntar = new Estado("nuevoMensaje-MenuArchivo-Adjuntar");
		aut.addTransicion(o, "adjuntar", "t, Right", adjuntar);
		rellenarMenuArchivoAdjuntar(aut);
		
		Estado guardarComo = new Estado("nuevoMensaje-MenuArchivo-GuardarComo");
		aut.addTransicion(o, "guardar como", "a", guardarComo);
		rellenarMenuArchivoGuardarComo(aut);
		
		aut.addTransicion(o, "enviar ahora", "v", aut.getEstadoInicial());
		aut.addTransicion(o, "enviar mas tarde", "t, t, Return", aut.getEstadoInicial());
		aut.addTransicion(o, "configurar pagina", "u", e);
		aut.addTransicion(o, "imprimir", "p", e);
		aut.addTransicion(o, "cerrar", "c", aut.getEstadoInicial());


		aut.addTransicion(o, "cancelar", "Escape", i);
	}
	
	public void rellenarMenuArchivoNuevo(Automata aut){
		Estado o = aut.getEstadoByName("nuevoMensaje-MenuArchivo-Nuevo");
		Estado i = aut.getEstadoNuevoMensaje();
		Estado e = aut.getEstadoByName("estadoEspera-Redactar");
		
		aut.addTransicion(o, "mensaje", "m", i);
		
		aut.addTransicion(o, "contacto de la libreta de direcciones", "c", e);
		aut.addTransicion(o, "cancelar", "Escape", i);
	}
	
	public void rellenarMenuArchivoAdjuntar(Automata aut){
		Estado o = aut.getEstadoByName("nuevoMensaje-MenuArchivo-Adjuntar");
		Estado i = aut.getEstadoNuevoMensaje();
		Estado e = aut.getEstadoByName("estadoEspera-Redactar");
		
		aut.addTransicion(o, "archivos", "v", e);
		aut.addTransicion(o, "adjuntar paginas web", "w", e);
		aut.addTransicion(o, "tarjeta personal", "p", i);
		
		aut.addTransicion(o, "cancelar", "Escape", i);
	}
	
	public void rellenarMenuArchivoGuardarComo(Automata aut){
		Estado o = aut.getEstadoByName("nuevoMensaje-MenuArchivo-GuardarComo");
		Estado i = aut.getEstadoNuevoMensaje();
		Estado e = aut.getEstadoByName("estadoEspera-Redactar");
		
		aut.addTransicion(o, "archivo", "a", e);
		aut.addTransicion(o, "borrador", "d", e);
		aut.addTransicion(o, "plantilla", "t", i);
		
		aut.addTransicion(o, "cancelar", "Escape", i);
	}
	
	public void rellenarMenuEditar(Automata aut){
		Estado o = aut.getEstadoByName("nuevoMensaje-MenuEditar");
		Estado i = aut.getEstadoNuevoMensaje();
		Estado e = aut.getEstadoByName("estadoEspera-Redactar");
		
		aut.addTransicion(o, "deshacer", "Escape, Control_L+Z", i);
		aut.addTransicion(o, "rehacer", "Escape, Shift_L+Control_L+Z", i);
		aut.addTransicion(o, "cortar", "Escape, Control_L+X", i);
		aut.addTransicion(o, "copiar", "Escape, Control_L+C", i);
		aut.addTransicion(o, "pegar", "Escape, Control_L+V", i);
		aut.addTransicion(o, "pegar sin formato", "Escape, Control_L+Shift_L+V", i);
		aut.addTransicion(o, "pegar como cita", "Escape, Control_L+Shift_L+O", i);
		aut.addTransicion(o, "eliminar", "Escape, Delete", i);
		aut.addTransicion(o, "reajuste de linea", "Escape, Control_L+R", i);
		aut.addTransicion(o, "renombrar adjunto", "Escape, F2", e);
		aut.addTransicion(o, "seleccionar todo", "Escape, Control_L+A", i);
		aut.addTransicion(o, "buscar y reemplazar", "b", e);
		aut.addTransicion(o, "repetir la busqueda", "q", i);
		aut.addTransicion(o, "buscar anterior", "Escape, Control_L+Shift_L+Return", i);
		aut.addTransicion(o, "configuracion de las cuentas", "Up,Up,Return", e);
		aut.addTransicion(o, "preferencias", "n", e);		

		aut.addTransicion(o, "cancelar", "Escape", e);
	}
	
	public void rellenarMenuVer(Automata aut){
		Estado o = aut.getEstadoByName("nuevoMensaje-MenuVer");
		Estado i = aut.getEstadoNuevoMensaje();
		Estado e = aut.getEstadoByName("estadoEspera-Redactar");
		
		
		aut.addTransicion(o, "barras de herramientas", 
				"h", new Estado("nuevoMensaje-MenuVer-BarrasDeHerramientas"));
		rellenarMenuVerBarrasDeHerramientas(aut);
		aut.addTransicion(o, "tama~no",
				"t", new Estado("nuevoMensaje-MenuVer-Tamano"));
		rellenarMenuVerTamano(aut);		
		aut.addTransicion(o, "panel lateral de contactos", "o", e);		
		aut.addTransicion(o, "informacion de seguridad del mensaje", "s", e);	
		
		aut.addTransicion(o, "cancelar", "Escape", i);		
	}
	
	public void rellenarMenuVerBarrasDeHerramientas(Automata aut){
		Estado o = aut.getEstadoByName("nuevoMensaje-MenuVer-BarrasDeHerramientas");
		Estado i = aut.getEstadoNuevoMensaje();
		Estado e = aut.getEstadoByName("estadoEspera-Redactar");		
		
		aut.addTransicion(o, "barra de herramientas de redaccion", "r", i);		
		aut.addTransicion(o, "barra de formato", "f", i);		
		aut.addTransicion(o, "barra de estado", "s", i);		
		aut.addTransicion(o, "personalizar", "p", e);		
		aut.addTransicion(o, "cancelar", "Escape", i);		
	}
	
	public void rellenarMenuVerTamano(Automata aut){
		Estado o = aut.getEstadoByName("nuevoMensaje-MenuVer-Tamano");
		Estado i = aut.getEstadoNuevoMensaje();
		
		aut.addTransicion(o, "aumentar solo el texto", "e", i);		
		aut.addTransicion(o, "aumentar tama~no", "a", i);		
		aut.addTransicion(o, "disminuir tama~no", "d", i);		
		aut.addTransicion(o, "restablecer", "r", i);	
		
		aut.addTransicion(o, "cancelar", "Escape", i);	
	}
	
	public void rellenarMenuInsertar(Automata aut){
		Estado o = aut.getEstadoByName("nuevoMensaje-MenuInsertar");
		Estado i = aut.getEstadoNuevoMensaje();
		Estado e = aut.getEstadoByName("estadoEspera-Redactar");
		
		aut.addTransicion(o, "imagen", "i", e);
		aut.addTransicion(o, "tabla", "t", e);
		aut.addTransicion(o, "enlace", "l", i);
		aut.addTransicion(o, "enlace interno con nombre", "a", i);
		aut.addTransicion(o, "linea horizontal", "o", i);
		aut.addTransicion(o, "hache te eme ele", "h", i);
		aut.addTransicion(o, "caracteres y simbolos", "c", i);
		
		aut.addTransicion(o, "tabla de contenidos", 
				"b", new Estado("nuevoMensaje-MenuInsertar-TablaDeContenidos")); 
		rellenarMenuInsertarTablaDeContenidos(aut);
		
		aut.addTransicion(o, "ruptura", "u", i);		
		
		aut.addTransicion(o, "cancelar", "Escape", i);	
	}	
	
	public void rellenarMenuInsertarTablaDeContenidos(Automata aut){
		Estado o = aut.getEstadoByName("nuevoMensaje-MenuInsertar-TablaDeContenidos");
		Estado i = aut.getEstadoNuevoMensaje();
		Estado e = aut.getEstadoByName("estadoEspera-Redactar");
		
		aut.addTransicion(o, "insertar", "i", e);
		aut.addTransicion(o, "actualizar", "Down,Return", i);
		aut.addTransicion(o, "eliminar", "Up,Return", i);

		aut.addTransicion(o, "cancelar", "Escape", i);
		
	}
	
	public void rellenarMenuFormato(Automata aut){
		Estado o = aut.getEstadoByName("nuevoMensaje-MenuFormato");
		Estado i = aut.getEstadoNuevoMensaje();
		Estado e = aut.getEstadoByName("estadoEspera-Redactar");
		
		aut.addTransicion(o, "tipo de letra", 
				"t,Right", new Estado("nuevoMensaje-MenuFormato-TipoDeLetra"));
		rellenarMenuFormatoTipoDeLetra(aut);
		
		aut.addTransicion(o, "tama~no", 
				"t,t,Right", new Estado("nuevoMensaje-MenuFormato-Tamano"));
		rellenarMenuFormatoTamano(aut);
		
		aut.addTransicion(o, "estilo de texto",
				"s", new Estado("nuevoMensaje-MenuFormato-EstiloDeTexto"));
		rellenarMenuFormatoEstiloDeTexto(aut);
		
		aut.addTransicion(o, "color del texto", "c", e);	
		aut.addTransicion(o, "descontinuar estilos de texto",
				"Escape,Shift_L+Control_L+Y", i);		
		aut.addTransicion(o, "descontinuar enlace", 
				"Escape,Shift_L+Control_L+K", i);		
		aut.addTransicion(o, "eliminar enlaces internos con nombre",
				"Escape,Shift_L+Control_L+R", i);		
		
		aut.addTransicion(o, "parrafo", 
				"p", new Estado("nuevoMensaje-MenuFormato-Parrafo"));
		rellenarMenuFormatoParrafo(aut);
		
		aut.addTransicion(o, "lista", 
				"l", new Estado("nuevoMensaje-MenuFormato-Lista"));
		rellenarMenuFormatoLista(aut);
		
		aut.addTransicion(o, "incrementar sangrado", "i", i);		
		aut.addTransicion(o, "reducir sangrado", "d", i);		
		
		aut.addTransicion(o, "alinear", 
				"a", new Estado("nuevoMensaje-MenuFormato-Alinear"));
		rellenarMenuFormatoAlinear(aut);
		
		aut.addTransicion(o, "tabla", "b", new Estado("nuevoMensaje-MenuFormato-Tabla"));
		rellenarMenuFormatoTabla(aut);
		
		aut.addTransicion(o, "propiedades de lista", "o", e);
		aut.addTransicion(o, "propiedades de celda de tabla", "o", e);
		aut.addTransicion(o, "propiedades de tabla", "o", e);
		aut.addTransicion(o, "propiedades avanzadas", "o", e);
		aut.addTransicion(o, "propiedades", "o", e);


		aut.addTransicion(o, "color y fondo de la pagina", "f", e);		
		
		aut.addTransicion(o, "cancelar", "Escape", i);	
	}
	
	public void rellenarMenuFormatoTipoDeLetra(Automata aut){
		Estado o = aut.getEstadoByName("nuevoMensaje-MenuFormato-TipoDeLetra");
		Estado i = aut.getEstadoNuevoMensaje();
		
		aut.addTransicion(o, "anchura variable", "v", i);	
		aut.addTransicion(o, "anchura fija", "f", i);		
		aut.addTransicion(o, "helvetica", "l", i);
		aut.addTransicion(o, "helvetica arial", "l", i);
		aut.addTransicion(o, "arial", "l", i);
		aut.addTransicion(o, "times", "t", i);
		aut.addTransicion(o, "taims", "t", i);
		aut.addTransicion(o, "courier", "c", i);
		aut.addTransicion(o, "curier", "c", i);
		aut.addTransicion(o, "abajo", "Down", i);		
		aut.addTransicion(o, "arriba", "Up", i);
		aut.addTransicion(o, "aceptar", "Return", i);	
		
		aut.addTransicion(o, "cancelar", "Escape", i);	
	}
	
	public void rellenarMenuFormatoTamano(Automata aut){
		Estado o = aut.getEstadoByName("nuevoMensaje-MenuFormato-Tamano");
		Estado i = aut.getEstadoNuevoMensaje();
		
		aut.addTransicion(o, "menor", "r", i);	
		aut.addTransicion(o, "mas grande", "g", i);		
		aut.addTransicion(o, "muy peque~no", "m", i);
		aut.addTransicion(o, "peque~no", "p", i);
		aut.addTransicion(o, "medio", "d", i);
		aut.addTransicion(o, "grande", "g", i);
		aut.addTransicion(o, "muy grande", "y", i);
		aut.addTransicion(o, "extragrande", "c", i);
		
		aut.addTransicion(o, "cancelar", "Escape", i);	
	}
	
	public void rellenarMenuFormatoEstiloDeTexto(Automata aut){
		Estado o = aut.getEstadoByName("nuevoMensaje-MenuFormato-EstiloDeTexto");
		Estado i = aut.getEstadoNuevoMensaje();
		
		aut.addTransicion(o, "negrita", "n,Return", i);	
		aut.addTransicion(o, "cursiva", "i", i);		
		aut.addTransicion(o, "subrayar", "u", i);
		aut.addTransicion(o, "tachado", "h", i);
		aut.addTransicion(o, "superindice", "p", i);
		aut.addTransicion(o, "subindice", "s", i);
		aut.addTransicion(o, "anchura fija", "f,Return", i);
		aut.addTransicion(o, "sin romper", "n,n,Return", i);
		aut.addTransicion(o, "enfasis", "f,f,Return", i);	
		aut.addTransicion(o, "mas enfasis", "f,f,f,Return", i);		
		aut.addTransicion(o, "cita", "c", i);
		aut.addTransicion(o, "abreviatura", "a", i);
		aut.addTransicion(o, "acronimo", "r", i);
		aut.addTransicion(o, "codigo", "o", i);
		aut.addTransicion(o, "aspecto de ejemplo", "m", i);
		aut.addTransicion(o, "variable", "v", i);
		
		aut.addTransicion(o, "cancelar", "Escape", i);	
	}
	
	public void rellenarMenuFormatoParrafo(Automata aut){
		Estado o = aut.getEstadoByName("nuevoMensaje-MenuFormato-Parrafo");
		Estado i = aut.getEstadoNuevoMensaje();
		
		aut.addTransicion(o, "cuerpo del texto", "t", i);	
		aut.addTransicion(o, "parrafo", "p", i);
		aut.addTransicion(o, "titulo uno", "1", i);
		aut.addTransicion(o, "titulo dos", "2", i);
		aut.addTransicion(o, "titulo tres", "3", i);
		aut.addTransicion(o, "titulo cuatro", "4", i);
		aut.addTransicion(o, "titulo cinco", "5", i);
		aut.addTransicion(o, "titulo seis", "6", i);
		aut.addTransicion(o, "direccion", "d", i);
		aut.addTransicion(o, "preformato", "f", i);
		
		aut.addTransicion(o, "cancelar", "Escape", i);	
	}
	
	public void rellenarMenuFormatoLista(Automata aut){
		Estado o = aut.getEstadoByName("nuevoMensaje-MenuFormato-Lista");
		Estado i = aut.getEstadoNuevoMensaje();
		Estado e = aut.getEstadoByName("estadoEspera-Redactar");

		
		aut.addTransicion(o, "ninguna", "n", i);	
		aut.addTransicion(o, "numerada", "o", i);
		aut.addTransicion(o, "no numerada", "m", i);
		aut.addTransicion(o, "termino", "t", i);
		aut.addTransicion(o, "definicion", "d", i);
		aut.addTransicion(o, "listar propiedades", "l", e);
		
		aut.addTransicion(o, "cancelar", "Escape", i);	
	}
	
	public void rellenarMenuFormatoAlinear(Automata aut){
		Estado o = aut.getEstadoByName("nuevoMensaje-MenuFormato-Alinear");
		Estado i = aut.getEstadoNuevoMensaje();

		
		aut.addTransicion(o, "izquierda", "i", i);	
		aut.addTransicion(o, "derecha", "r", i);
		aut.addTransicion(o, "centrar", "c", i);
		aut.addTransicion(o, "justificar", "j", i);
		
		aut.addTransicion(o, "cancelar", "Escape", i);	
	}
	
	public void rellenarMenuFormatoTabla(Automata aut){
		Estado o = aut.getEstadoByName("nuevoMensaje-MenuFormato-Tabla");
		Estado i = aut.getEstadoNuevoMensaje();
		Estado e = aut.getEstadoByName("estadoEspera-Redactar");
		
		aut.addTransicion(o, "insertar",
				"i", new Estado("nuevoMensaje-MenuFormato-Tabla-Insertar"));
		rellenarMenuFormatoTablaInsertar(aut);
		
		aut.addTransicion(o, "seleccionar",
				"s", new Estado("nuevoMensaje-MenuFormato-Tabla-Seleccionar"));
		rellenarMenuFormatoTablaSeleccionar(aut);
		
		aut.addTransicion(o, "eliminar",
				"l", new Estado("nuevoMensaje-MenuFormato-Tabla-Eliminar"));
		rellenarMenuFormatoTablaEliminar(aut);
		
		aut.addTransicion(o, "unir celdas seleccionadas", "u", i);
		aut.addTransicion(o, "unir", "u", i);
		aut.addTransicion(o, "unir a la cleda de la derecha", "u", i);
		aut.addTransicion(o, "dividir celda", "Up,Up,Up,Return", i);
		aut.addTransicion(o, "dividir", "Up,Up,Up,Return", i);
		aut.addTransicion(o, "crear tabla a partir de la seleccion", "r", i);
		aut.addTransicion(o, "color de fondo de la tabla", "b", e);
		aut.addTransicion(o, "color de fondo de la tabla o celda", "b", e);
		aut.addTransicion(o, "color de fondo de la celda", "b", e);
		aut.addTransicion(o, "propiedades de la tabla", "o", e);
		
		aut.addTransicion(o, "cancelar", "Escape", i);	
	}
	
	public void rellenarMenuFormatoTablaInsertar(Automata aut){
		Estado o = aut.getEstadoByName("nuevoMensaje-MenuFormato-Tabla-Insertar");
		Estado i = aut.getEstadoNuevoMensaje();
		Estado e = aut.getEstadoByName("estadoEspera-Redactar");
		
		aut.addTransicion(o, "tabla", "t", e);
		aut.addTransicion(o, "fila superior", "f", i);
		aut.addTransicion(o, "fila inferior", "i", i);
		aut.addTransicion(o, "columna anterior", "o", i);
		aut.addTransicion(o, "columna siguiente", "a", i);
		aut.addTransicion(o, "celda anterior", "c", i);
		aut.addTransicion(o, "celda siguiente", "u", i);
		
		aut.addTransicion(o, "cancelar", "Escape", i);	
	}
	
	public void rellenarMenuFormatoTablaSeleccionar(Automata aut){
		Estado o = aut.getEstadoByName("nuevoMensaje-MenuFormato-Tabla-Seleccionar");
		Estado i = aut.getEstadoNuevoMensaje();
		Estado e = aut.getEstadoByName("estadoEspera-Redactar");
		
		aut.addTransicion(o, "tabla", "t", e);
		aut.addTransicion(o, "fila", "f", i);
		aut.addTransicion(o, "columna", "o", i);
		aut.addTransicion(o, "celda", "c", i);
		aut.addTransicion(o, "todas las celdas", "a", i);
		
		aut.addTransicion(o, "cancelar", "Escape", i);	
	}
	
	public void rellenarMenuFormatoTablaEliminar(Automata aut){
		Estado o = aut.getEstadoByName("nuevoMensaje-MenuFormato-Tabla-Eliminar");
		Estado i = aut.getEstadoNuevoMensaje();
		Estado e = aut.getEstadoByName("estadoEspera-Redactar");
		
		aut.addTransicion(o, "tabla", "t", e);
		aut.addTransicion(o, "tablas", "t", e);
		aut.addTransicion(o, "fila", "f", i);
		aut.addTransicion(o, "filas", "f", i);
		aut.addTransicion(o, "columna", "o", i);
		aut.addTransicion(o, "columnas", "o", i);
		aut.addTransicion(o, "celda", "c", i);
		aut.addTransicion(o, "celdas", "c", i);
		aut.addTransicion(o, "contenido de la celda", "n", i);		
		
		aut.addTransicion(o, "cancelar", "Escape", i);	
	}	
	
	public void rellenarMenuOpciones(Automata aut){
		Estado o = aut.getEstadoByName("nuevoMensaje-MenuOpciones");
		Estado i = aut.getEstadoNuevoMensaje();
		Estado e = aut.getEstadoByName("estadoEspera-Redactar");
		
		aut.addTransicion(o, "revisar ortografia", "o", e);
		aut.addTransicion(o, "revisar mientras se escribe", "s", i);
		aut.addTransicion(o, "citar mensaje", "m", i);
		aut.addTransicion(o, "acuse de recibo", "d", i);
		aut.addTransicion(o, "notificacion de estado de entrega", "n", i);
		
		aut.addTransicion(o, "codificacion de caracteres",
				"c", new Estado("nuevoMensaje-MenuOpciones-CodificacionDeCaracteres"));
		rellenarMenuOpcionesCodificacion(aut);
		
		aut.addTransicion(o, "formato de entrega", 
				"f,Right", new Estado("nuevoMensaje-MenuOpciones-FormatoDeEntrega"));
		rellenarMenuOpcionesFormatoDeEntrega(aut);
		
		aut.addTransicion(o, "prioridad",
				"p", new Estado("nuevoMensaje-MenuOpciones-Prioridad"));
		rellenarMenuOpcionesPrioridad(aut);
		
		Estado m = new Estado("modoManualRedactar");
		aut.addTransicion(o, "enviar una copia a", "v", m);
		rellenarModoManualRedactar(aut);
		
		aut.addTransicion(o, "cifrar este mensaje", "e", e);
		aut.addTransicion(o, "firmar digitalmente este mensaje", "f,f,Return", e); 

		aut.addTransicion(o, "cancelar", "Escape", i);		
	}
	
	public void rellenarMenuOpcionesFormatoDeEntrega(Automata aut){
		Estado o = aut.getEstadoByName("nuevoMensaje-MenuOpciones-FormatoDeEntrega");
		Estado i = aut.getEstadoNuevoMensaje();
		
		aut.addTransicion(o, "autodetectar", "a", i);		
		aut.addTransicion(o, "solo texto sin formato", "s", i);		
		aut.addTransicion(o, "solo texto enriquecido", "r", i);		
		aut.addTransicion(o, "texto simple y texto enriquecido", "l", i);	
		
		aut.addTransicion(o, "cancelar", "Escape", i);		
	}
	
	public void rellenarMenuOpcionesCodificacion(Automata aut){
		Estado o = aut.getEstadoByName("nuevoMensaje-MenuOpciones-CodificacionDeCaracteres");
		Estado i = aut.getEstadoNuevoMensaje();
		Estado e = aut.getEstadoByName("estadoEspera-Redactar");

		
		aut.addTransicion(o, "personalizar lista", "p", e);		
		aut.addTransicion(o, "arriba", "Up", i);		
		aut.addTransicion(o, "abajo", "Down", i);		
		aut.addTransicion(o, "aceptar", "Return", i);	
		
		aut.addTransicion(o, "cancelar", "Escape", i);		
	}
	
	public void rellenarMenuOpcionesPrioridad(Automata aut){
		Estado o = aut.getEstadoByName("nuevoMensaje-MenuOpciones-Prioridad");
		Estado i = aut.getEstadoNuevoMensaje();
		
		aut.addTransicion(o, "la mas alta", "l", i);		
		aut.addTransicion(o, "alta", "a", i);		
		aut.addTransicion(o, "normal", "n", i);		
		aut.addTransicion(o, "baja", "b", i);		
		aut.addTransicion(o, "la mas baja", "m", i);	
		
		aut.addTransicion(o, "cancelar", "Escape", i);		
	}
	
	public void rellenarMenuHerramientas(Automata aut){
		Estado o = aut.getEstadoByName("nuevoMensaje-MenuHerramientas");
		Estado i = aut.getEstadoNuevoMensaje();
		
		aut.addTransicion(o, "correo y noticias", 
				"o,Alt_L+Tab,Alt_L+F4", aut.getEstadoInicial());
		aut.addTransicion(o, "libreta de direcciones", 
				"l,Alt_L+Tab,Alt_L+F4", aut.getEstadoLibretaDirecciones());
		aut.addTransicion(o, "cancelar", "Escape", i);		
	}
	
	public void rellenarMenuAyuda(Automata aut){
		Estado o = aut.getEstadoByName("nuevoMensaje-MenuAyuda");
		Estado i = aut.getEstadoNuevoMensaje();
		Estado e = aut.getEstadoByName("estadoEspera-Redactar");
		
		aut.addTransicion(o, "acerca de thunderbird", "t", e);
		aut.addTransicion(o, "acerca de zanderberd", "t", e);
		aut.addTransicion(o, "contenidos de la ayuda", "u", e);
		aut.addTransicion(o, "notas de esta version", "n", aut.getEstadoInicial());
		aut.addTransicion(o, "que hay de nuevo", "q", aut.getEstadoInicial());
		aut.addTransicion(o, "reiniciar con los complementos desactivados", 
				"r", aut.getEstadoInicial());

		aut.addTransicion(o, "cancelar", "Escape", i);		
	}
	
	public void rellenarModoManualRedactar(Automata aut){
		Estado o = aut.getEstadoByName("modoManualRedactar");
		Estado i = aut.getEstadoNuevoMensaje();
		
		aut.addTransicion(o, "arriba", "Up", o);
		aut.addTransicion(o, "abajo", "Down", o);
		aut.addTransicion(o, "izquierda", "Left", o);
		aut.addTransicion(o, "derecha", "Right", o);
		aut.addTransicion(o, "aceptar", "Return", o);
		aut.addTransicion(o, "entrar", "Right", o);
		aut.addTransicion(o, "cancelar", "Escape", o);
		aut.addTransicion(o, "continuar", "", i);
	}
	
}
