package Gestores;

import Clases.Automata;
import Clases.Estado;
import Principal.TecladoUtils;

public class GestorPaginaPrincipal {

	TecladoUtils u;
	
	public GestorPaginaPrincipal(){
		u = new TecladoUtils();
	}
	
	public void rellenarPaginaPrincipal(Automata aut){
		Estado pr = aut.getEstadoInicial();
		Estado n = aut.getEstadoNuevoMensaje();
				
		rellenarModoManual(aut);
		
		// Diferentes formas de acceder a los menus
		Estado menuArchivo = new Estado("menuArchivo");
		aut.addTransicion(pr, "abrir menu archivo", "Alt_L+a",menuArchivo);
		aut.addTransicion(pr, "menu archivo", "Alt_L+a",menuArchivo);
		
		Estado menuEditar = new Estado("menuEditar");
		aut.addTransicion(pr, "abrir menu editar", "Alt_L+e",menuEditar);
		aut.addTransicion(pr, "menu editar", "Alt_L+e",menuEditar);
		
		Estado menuVer = new Estado("menuVer");
		aut.addTransicion(pr, "abrir menu ver", "Alt_L+v",menuVer);
		aut.addTransicion(pr, "menu ver", "Alt_L+v",menuVer);
		
		Estado menuIr = new Estado("menuIr");
		aut.addTransicion(pr, "abrir menu ir", "Alt_L+i",menuIr);
		aut.addTransicion(pr, "menu ir", "Alt_L+i",menuIr);
		
		Estado menuMensaje = new Estado("menuMensaje");
		aut.addTransicion(pr, "abrir menu mensaje", "Alt_L+m",menuMensaje);
		aut.addTransicion(pr, "menu mensaje", "Alt_L+m", menuMensaje);
		
		Estado menuHerramientas = new Estado("menuHerramientas");
		aut.addTransicion(pr, "abrir menu herramientas", "Alt_L+t",menuHerramientas);
		aut.addTransicion(pr, "menu herramientas", "Alt_L+t",menuHerramientas);
		
		Estado menuAyuda = new Estado("menuAyuda");
		aut.addTransicion(pr, "abrir menu ayuda", "Alt_L+u",menuAyuda);
		aut.addTransicion(pr, "menu ayuda", "Alt_L+u",menuAyuda);
		
		rellenarMenuArchivo(aut);
		rellenarMenuEditar(aut);
		rellenarMenuVer(aut);
		rellenarMenuIr(aut);
		rellenarMenuMensaje(aut);
		rellenarMenuHerramientas(aut);
		rellenarMenuAyuda(aut);
		
		aut.addTransicion(pr, "recibir", "F5", pr);
		aut.addTransicion(pr, "recibir todos los mensajes nuevos",
				"Shift_L+F5",pr);
		aut.addTransicion(pr, "redactar", "Control_L+N", n);
		
		aut.addTransicion(pr, "charlar", "Alt_L+I, H",pr);
		aut.addTransicion(pr, "etiqueta","Alt+M, U", pr);
		aut.addTransicion(pr, "cambiar carpeta", 
				"Alt+I,a,a,Right", aut.getEstadoManual());	
		Estado e2 = new Estado("estadoEspera");
		e2.addTransicion("continuar", "F6", pr);
		aut.addTransicion(pr, "filtro rapido",
				"Control_L+Shift_L+k", e2);
		aut.addTransicion(pr, "direcciones",
				"Shift_L+Control_L+b", aut.getEstadoLibretaDirecciones());
		aut.addTransicion(pr, "buscar",
				"Control_L+k", aut.getEstadoManual());
		aut.addTransicion(pr, "siguiente mensaje", "f", pr);
		aut.addTransicion(pr, "anterior mensaje", "b", pr);
		aut.addTransicion(pr, "mensaje siguiente", "f", pr);
		aut.addTransicion(pr, "mensaje anterior", "b", pr);
		aut.addTransicion(pr, "abrir mensaje", "Control_L+o", pr);
		aut.addTransicion(pr, "abrir mensaje en la conversacion",
				"Control_L+Shift_L+o", pr);
		aut.addTransicion(pr, "siguiente pesta~na", 
				"Control_L+Tab", pr);
		aut.addTransicion(pr, "pesta~na siguiente", 
				"Control_L+Tab", pr);
		aut.addTransicion(pr, "anterior pesta~na", 
				"Control_L+Shift_L+Tab", pr);
		aut.addTransicion(pr, "pesta~na anterior",
				"Control_L+Shift_L+Tab", pr);
		aut.addTransicion(pr, "cerrar pesta~na", 
				"Control_L+w", pr); //TODO opcional: cerrar si es la última pestaña
		aut.addTransicion(pr, "salir", 
				"Alt_L+F4", aut.getEstadoFin());
		aut.addTransicion(pr, "salir del programa",
				"Alt_L+F4", aut.getEstadoFin());
		aut.addTransicion(pr, "cerrar programa",
				"Alt_L+F4", aut.getEstadoFin());
		
		// Transiciones relacionadas con los mensajes
		aut.addTransicion(pr, "responder", "Control_L+R",n);
		aut.addTransicion(pr, "responder a todos",
				"Control_L+Shift_L+R",n);
		aut.addTransicion(pr, "reenviar", "Control_L+L",n);
		aut.addTransicion(pr, "archivar", "A",pr);
		aut.addTransicion(pr, "no deseado", "J",pr);
		aut.addTransicion(pr, "legitimo", "Shift_L+J",pr);
		aut.addTransicion(pr, "eliminar", "Delete",pr);
		aut.addTransicion(pr, "a~nadir estrella", "s",pr);
		aut.addTransicion(pr, "quitar estrella", "s",pr);
		aut.addTransicion(pr, "estrella", "s",pr);
		aut.addTransicion(pr, "subir", "Page_Up",pr);
		aut.addTransicion(pr, "bajar", "Page_Down",pr);
		aut.addTransicion(pr, "guardar archivos adjuntos",
				"Alt+m,D",aut.getEstadoManual());
		aut.addTransicion(pr, "guardar todos los adjuntos",
				"Alt+m,D,G",pr);		
	}

	public void rellenarMenuAyuda(Automata aut){
		Estado o = aut.getEstadoByName("menuAyuda");
		Estado e = aut.getEstadoEspera();
		Estado i = aut.getEstadoInicial();
		
		aut.addTransicion(o, "acerca de thunderbird", "t", e);
		aut.addTransicion(o, "acerca de zanderberd", "t", e);
		aut.addTransicion(o, "contenidos de la ayuda", "u", e);
		
		aut.addTransicion(o, "informacion sobre la resolucion de problemas", 
				"i", i);
		
		aut.addTransicion(o, "notas de esta version", "n", i);		
		aut.addTransicion(o, "que hay de nuevo", "q", i);		
		aut.addTransicion(o, "reiniciar con los complementos desactivados", "r", i);
		
		aut.addTransicion(o, "cancelar", "Escape", i);
	}
	
	public void rellenarMenuArchivoNuevo(Automata aut) {
		Estado o = aut.getEstadoByName("menuArchivo-Nuevo");
		Estado i = aut.getEstadoInicial();
		Estado e = aut.getEstadoEspera();
		aut.addTransicion(o, "mensaje",	"m", e);		
		aut.addTransicion(o, "subcarpeta",  "c", e);		
		aut.addTransicion(o, "carpeta", "c", e);		
		aut.addTransicion(o, "busqueda guardada", "b", e);	
		
		aut.addTransicion(o, "obtener una nueva cuenta de correo",
				"o,Return",	e);
		
		aut.addTransicion(o, "cuenta de correo existente", "e", e);
		aut.addTransicion(o, "cuenta de chat", "h", e);
		aut.addTransicion(o, "cuenta de canales web", "w", e);
		aut.addTransicion(o, "otras cuentas", "o,o,Return", e);
		
		aut.addTransicion(o, "contacto de la libreta de direcciones",
				"c", e);
		
		aut.addTransicion(o, "cancelar", "Escape",i);
	}
	public void rellenarMenuArchivoGuardarComo(Automata aut){
		Estado o = aut.getEstadoByName("menuArchivo-GuardarComo");
		Estado e = aut.getEstadoEspera();
		
		aut.addTransicion(o, "archivo",	"r", e); 		
		aut.addTransicion(o, "plantilla", "p", e);
		
		aut.addTransicion(o, "cancelar", "Escape", aut.getEstadoInicial());
	}
	
	public void rellenarMenuArchivoRecibirMensajesNuevosDe(Automata aut){
		Estado o = aut.getEstadoByName("menuArchivo-RecibirMensajesNuevosDe");
		Estado i = aut.getEstadoInicial();
		
		aut.addTransicion(o, "cuenta actual", "c", i);		
		aut.addTransicion(o, "todas las cuentas",  "t", i);		
		aut.addTransicion(o, "arriba", "Up", o);
		aut.addTransicion(o, "abajo", "Down", o);
		aut.addTransicion(o, "aceptar", "Return", i);
		
		aut.addTransicion(o, "cancelar", "Escape",i);
	}
	
	public void rellenarMenuArchivoSinConexion(Automata aut){
		Estado o = aut.getEstadoByName("menuArchivo-SinConexion");
		Estado i = aut.getEstadoInicial();
		Estado e = aut.getEstadoEspera();
		
		aut.addTransicion(o, "trabajar sin conexion", "t", i);
		
		aut.addTransicion(o, "sincronizar ahora", "s", i);
		aut.addTransicion(o, "sincronizar descargar ahora", "s", i);
		aut.addTransicion(o, "descargar ahora", "s", i);
		
		aut.addTransicion(o, "configuracion sin conexion", "e", e);
		
		aut.addTransicion(o, "descargar mensajes con estrella",
				"a", i);
		
		aut.addTransicion(o, "descargar mensajes seleccionados",
				"l", i);
		
		aut.addTransicion(o, "cancelar", "Escape",i);
	}
	

	
	public void rellenarMenuArchivo(Automata aut){
		Estado o = aut.getEstadoByName("menuArchivo");
		Estado i = aut.getEstadoInicial();
		Estado e = aut.getEstadoEspera();
		
		aut.addTransicion(o, "cancelar", "Escape", i);
		
		Estado menuArchivoNuevo = new Estado("menuArchivo-Nuevo");
		aut.addTransicion(o, "nuevo",
				"n", menuArchivoNuevo);
		rellenarMenuArchivoNuevo(aut);
		
		aut.addTransicion(o, "abrir mensaje guardado", "a",e); 	
		
		aut.addTransicion(o, "cerrar","c",aut.getEstadoFin());
		
		Estado menuArchivoGuardarComo = new Estado("menuArchivo-GuardarComo");
		aut.addTransicion(o, "guardar como", "g", menuArchivoGuardarComo);
		rellenarMenuArchivoGuardarComo(aut);
		
		Estado menuArchivoRecibirMensajesNuevosDe = new Estado("menuArchivo-RecibirMensajesNuevosDe");
		aut.addTransicion(o, "recibir mensajes nuevos de",	
				"b, Right",	menuArchivoRecibirMensajesNuevosDe);
		rellenarMenuArchivoRecibirMensajesNuevosDe(aut);
		
		aut.addTransicion(o, "procesar mensajes no enviados", "b,Down,Return", i);		
		aut.addTransicion(o, "suscribirse", "b,b,Return", e);		
		aut.addTransicion(o, "eliminar carpeta", "e", i); 		
		aut.addTransicion(o, "renombrar carpeta", "Escape, F2", e);		
		aut.addTransicion(o, "compactar carpetas", "x,Left,Up,Up,Return", i); 		
		aut.addTransicion(o, "vaciar papelera", "p", i); 
		
		Estado menuArchivoSinConexion = new Estado("menuArchivo-SinConexion");
		aut.addTransicion(o, "sin conexion",
				"x", menuArchivoSinConexion);
		rellenarMenuArchivoSinConexion(aut);
		
		aut.addTransicion(o, "configurar pagina", "u", e);		
		aut.addTransicion(o, "vista preliminar", "v", e);		
		aut.addTransicion(o, "imprimir", "i", e);		
		aut.addTransicion(o, "salir", "s", aut.getEstadoFin());
	}
	public void rellenarMenuEditar(Automata aut){
		Estado o = aut.getEstadoByName("menuEditar");
		Estado i = aut.getEstadoInicial();
		Estado e = aut.getEstadoEspera();
		
		aut.addTransicion(o, "deshacer", "h", i);		
		aut.addTransicion(o, "rehacer", "r", i);
		
		aut.addTransicion(o, "cortar", "t", i);		
		aut.addTransicion(o, "copiar", "c",i);		
		aut.addTransicion(o, "pegar", "p", i);
		
		aut.addTransicion(o, "eliminar mensaje", "Escape, supr", i);
		
		Estado menuEditarSeleccionar = new Estado("menuEditar-Seleccionar");
		aut.addTransicion(o, "seleccionar",  "l", menuEditarSeleccionar);
		rellenarMenuEditarSeleccionar(aut);
		
		Estado menuEditarBuscar = new Estado("menuEditar-Buscar");
		aut.addTransicion(o, "buscar",  "b", menuEditarBuscar);
		rellenarMenuEditarBuscar(aut);
		
		aut.addTransicion(o, "carpeta favorita",  "v", i);
		aut.addTransicion(o, "propiedades de carpeta",  "o", e);
		aut.addTransicion(o, "configuracion de las cuentas",  "a", e);
		aut.addTransicion(o, "preferencias",  "n", e);
		
		aut.addTransicion(o, "cancelar",  "Escape", i);	
	}
	
	public void rellenarMenuEditarSeleccionar(Automata aut){
		Estado o = aut.getEstadoByName("menuEditar-Seleccionar");
		Estado i = aut.getEstadoInicial();
		
		aut.addTransicion(o, "todos", "t", i);
		aut.addTransicion(o, "mensajes con estrella", "s", i);
		aut.addTransicion(o, "conversacion", "c", i);
		
		aut.addTransicion(o, "cancelar", "Escape", i);		
	}
	
	public void rellenarMenuEditarBuscar(Automata aut){
		Estado o = aut.getEstadoByName("menuEditar-Buscar");
		Estado i = aut.getEstadoInicial();
		
		aut.addTransicion(o, "buscar direcciones", "s", i);
		aut.addTransicion(o, "buscar en este mensaje", "b", i);
		aut.addTransicion(o, "buscar mensajes", "m", i);
		aut.addTransicion(o, "repetir la busqueda", "q", i);
		
		aut.addTransicion(o, "cancelar", "Escape", i);
	}
	
	public void rellenarMenuVer(Automata aut){
		Estado o = aut.getEstadoByName("menuVer");
		Estado i = aut.getEstadoInicial();
		Estado e = aut.getEstadoEspera();
		
		Estado verBarras = new Estado("menuVer-BarrasDeHerramientas");
		aut.addTransicion(o, "barras de herramientas", "h", verBarras);
		rellenarMenuVerBarrasDeHerramientas(aut);
		
		Estado verDisposicion = new Estado("menuVer-Disposicion");
		aut.addTransicion(o, "disposicion", "d", verDisposicion);
		rellenarMenuVerDisposicion(aut);
		
		Estado verCarpetas = new Estado("menuVer-Carpetas");
		aut.addTransicion(o, "carpetas", "p", verCarpetas);
		rellenarMenuVerCarpetas(aut);

		Estado verOrdenarPor = new Estado("menuVer-OrdenarPor");
		aut.addTransicion(o, "ordenar por", "o", verOrdenarPor);
		rellenarMenuVerOrdenarPor(aut);
		
		Estado verConversaciones = new Estado("menuVer-Conversaciones");
		aut.addTransicion(o, "conversaciones", "v", verConversaciones);
		rellenarMenuVerConversaciones(aut);
		
		Estado verCabeceras = new Estado("menuVer-Cabeceras");
		aut.addTransicion(o, "cabeceras", "c,Right", verCabeceras);
		rellenarMenuVerCabeceras(aut);
		
		Estado verCuerpoComo = new Estado("menuVer-CuerpoDelMensajeComo");
		aut.addTransicion(o, "cuerpo del mensaje como", 
				"u", verCuerpoComo);
		rellenarMenuVerCuerpoComo(aut);		
		
		Estado verTamano = new Estado("menuVer-Tamanyo");
		aut.addTransicion(o, "tama~no", "t", verTamano);
		rellenarMenuVerTamanyo(aut);
		
		Estado verCodificacion = new Estado("menuVer-CodificacionDeCaracteres");
		aut.addTransicion(o, "codificacion de caracteres", 
				"c,c,Right", verCodificacion);
		rellenarMenuVerCodificacion(aut);
		
		aut.addTransicion(o, "ver adjuntos incorporados", "a", i);
		aut.addTransicion(o, "formato original del mensaje", "f", e);
		aut.addTransicion(o, "informacion de seguridad del mensaje", "s", i);

		aut.addTransicion(o, "cancelar", "Escape",i);
	}
	
	public void rellenarMenuVerBarrasDeHerramientas(Automata aut) {
		Estado o = aut.getEstadoByName("menuVer-BarrasDeHerramientas");
		Estado i = aut.getEstadoInicial();
		Estado e = aut.getEstadoEspera();
		
		aut.addTransicion(o, "barra de herramientas de correo", "c",i);
		aut.addTransicion(o, "barra de menu", "m",i);
		aut.addTransicion(o, "barra de estado", "b",i);
		aut.addTransicion(o, "barra de filtrado rapido", "f",i);
		aut.addTransicion(o, "personalizar", "p",e);
		
		aut.addTransicion(o, "cancelar", "Escape",i);
	}
	
	public void rellenarMenuVerDisposicion(Automata aut) {
		Estado o = aut.getEstadoByName("menuVer-Disposicion");
		Estado i = aut.getEstadoInicial();
		
		aut.addTransicion(o, "vista clasica", "Return",i);
		aut.addTransicion(o, "vista amplia", "a",i);
		aut.addTransicion(o, "vista vertical", "v",i);
		aut.addTransicion(o, "panel de carpetas", "Up,Up,Return",i);
		aut.addTransicion(o, "mensaje", "e",i);
		
		aut.addTransicion(o, "cancelar", "Escape",i);
	}
	
	
	public void rellenarMenuVerCarpetas(Automata aut){
		Estado o = aut.getEstadoByName("menuVer-Carpetas");
		Estado i = aut.getEstadoInicial();
		
		aut.addTransicion(o, "todas", "t",i);
		aut.addTransicion(o, "unificadas", "n,Return",i);
		aut.addTransicion(o, "con no leidos", "n,n,Return",i);
		aut.addTransicion(o, "favoritas", "f",i);
		aut.addTransicion(o, "recientes", "r",i);

		
		aut.addTransicion(o, "cancelar", "Escape",i);
	}
	
	
	public void rellenarMenuVerOrdenarPor(Automata aut) {
		Estado o = aut.getEstadoByName("menuVer-OrdenarPor");
		Estado i = aut.getEstadoInicial();
		
		aut.addTransicion(o, "fecha", "f",i);
		aut.addTransicion(o, "recibido", "b",i);
		aut.addTransicion(o, "estrella", "s,Return",i);
		aut.addTransicion(o, "orden de recepcion", "o",i);
		aut.addTransicion(o, "prioridad", "p",i);
		aut.addTransicion(o, "remitente", "r",i);
		aut.addTransicion(o, "destinatario", "d,Return",i);
		aut.addTransicion(o, "tama~no", "t",i);
		aut.addTransicion(o, "estado", "e",i);
		aut.addTransicion(o, "asunto", "a,Return",i);
		aut.addTransicion(o, "leidos", "l",i);
		aut.addTransicion(o, "etiquetas", "q",i);
		aut.addTransicion(o, "estado de correo no deseado", "s,s,Return",i);
		aut.addTransicion(o, "adjuntos", "a,a,Return",i);
		aut.addTransicion(o, "ascendente", "a,a,a,Return",i);
		aut.addTransicion(o, "descendente", "d,d,Return",i);
		aut.addTransicion(o, "anidado", "a,a,a,a,Return",i);
		aut.addTransicion(o, "no anidado", "n",i);
		aut.addTransicion(o, "agrupados por orden", "g",i);

		
		aut.addTransicion(o, "cancelar", "Escape",i);
	}
	
	public void rellenarMenuVerConversaciones(Automata aut) {
		Estado o = aut.getEstadoByName("menuVer-Conversaciones");
		Estado i = aut.getEstadoInicial();
		
		aut.addTransicion(o, "todas", "t",i);
		aut.addTransicion(o, "mensajes no leidos", "n",i);
		aut.addTransicion(o, "conversaciones con mensajes no leidos",
				"o",i);
		aut.addTransicion(o, "conversaciones observadas con mensajes no leidos",
				"v",i);
		aut.addTransicion(o, "conversaciones observadas",
				"i",i);
		aut.addTransicion(o, "expandir todas las conversaciones",
				"e",i);
		aut.addTransicion(o, "contraer todas las conversaciones",
				"c",i);
	
		aut.addTransicion(o, "cancelar", "Escape",i);
	}

	public void rellenarMenuVerCabeceras(Automata aut) {
		Estado o = aut.getEstadoByName("menuVer-Cabeceras");
		Estado i = aut.getEstadoInicial();
		
		aut.addTransicion(o, "todas", "t",i);
		aut.addTransicion(o, "normal", "n",i);
		
		aut.addTransicion(o, "cancelar", "Escape",i);
	}

	public void rellenarMenuVerCuerpoComo(Automata aut) {
		Estado o = aut.getEstadoByName("menuVer-CuerpoDelMensajeComo");
		Estado i = aut.getEstadoInicial();

		aut.addTransicion(o, "hache te eme ele original", "h",i);
		aut.addTransicion(o, "hache te eme ele simple", "s",i);
		aut.addTransicion(o, "texto sin formato", "t",i);
		
		aut.addTransicion(o, "cancelar", "Escape",i);
	}
	
	public void rellenarMenuVerTamanyo(Automata aut) {
		Estado o = aut.getEstadoByName("menuVer-Tamanyo");
		Estado i = aut.getEstadoInicial();
		
		aut.addTransicion(o, "aumentar tama~no", "a",i);
		aut.addTransicion(o, "disminuir tama~no", "D",i);
		aut.addTransicion(o, "restablecer", "r",i);
		aut.addTransicion(o, "aumentar solo el texto", "e",i);

		aut.addTransicion(o, "cancelar", "Escape",i);
	}
	
	@SuppressWarnings("unused")
	public void rellenarMenuVerCodificacion(Automata aut) {
		Estado o = aut.getEstadoByName("menuVer-CodificacionDeCaracteres");
		Estado i = aut.getEstadoInicial();
		Estado e = aut.getEstadoEspera();
		
		aut.addTransicion(o, "autodetectar", "a",aut.getEstadoManual());
		aut.addTransicion(o, "mas", "m",aut.getEstadoManual());
		aut.addTransicion(o, "personalizar lista", "p",aut.getEstadoManual());
		aut.addTransicion(o, "arriba", "Up", o);
		aut.addTransicion(o, "abajo", "Down", o);
		aut.addTransicion(o, "izquierda",
				"Left", aut.getEstadoByName("menuVer"));
		aut.addTransicion(o, "derecha", "Right", aut.getEstadoManual());
		aut.addTransicion(o, "aceptar", "Return", i);
		aut.addTransicion(o, "entrar", "Right", aut.getEstadoManual());

		aut.addTransicion(o, "cancelar", "Escape",i);
	}	
	
	public void rellenarMenuIr(Automata aut){
		Estado o = aut.getEstadoByName("menuIr");
		Estado i = aut.getEstadoInicial();
		
		Estado irSiguiente = new Estado("menuIr-Siguiente");
		aut.addTransicion(o, "siguiente", "s", irSiguiente);
		rellenarMenuIrSiguiente(aut);
		
		Estado irAnterior = new Estado("menuIr-Anterior");
		aut.addTransicion(o, "anterior", "a,Right", irAnterior);
		rellenarMenuIrAnterior(aut);
		
		aut.addTransicion(o, "adelante", "d", i);
		aut.addTransicion(o, "atras", "t", i);
		aut.addTransicion(o, "charlar", "h", i);
		
		Estado irCarpeta = new Estado("menuIr-Carpeta");
		aut.addTransicion(o, "carpeta", "a,a,Right", irCarpeta);
		rellenarMenuIrCarpeta(aut);
		
		aut.addTransicion(o, "pesta~nas cerradas recientemente", 
				"Up,Up,Right", aut.getEstadoManual());
		
		aut.addTransicion(o, "pagina de inicio del correo", 
				"Up,Return", i);

		aut.addTransicion(o, "cancelar", "Escape",i);
	}
	
	public void rellenarMenuIrSiguiente(Automata aut){
		Estado o = aut.getEstadoByName("menuIr-Siguiente");
		Estado i = aut.getEstadoInicial();
		
		aut.addTransicion(o, "mensaje", "m", i);
		aut.addTransicion(o, "mensaje no leido", "n", i);
		aut.addTransicion(o, "mensaje con estrella", "s", i);
		aut.addTransicion(o, "conversacion no leida", "v", i);

		aut.addTransicion(o, "cancelar", "Escape",i);
	}
	
	public void rellenarMenuIrAnterior(Automata aut){
		Estado o = aut.getEstadoByName("menuIr-Anterior");
		Estado i = aut.getEstadoInicial();
		
		aut.addTransicion(o, "mensaje", "m", i);
		aut.addTransicion(o, "mensaje no leido", "n", i);
		aut.addTransicion(o, "mensaje con estrella", "s", i);
		
		aut.addTransicion(o, "cancelar", "Escape",i);
	}
	
	public void rellenarMenuIrCarpeta(Automata aut){
		Estado o = aut.getEstadoByName("menuIr-Carpeta");
		Estado i = aut.getEstadoInicial();
		
		aut.addTransicion(o, "reciente", "r", aut.getEstadoManual());
		aut.addTransicion(o, "arriba", "Up", o);
		aut.addTransicion(o, "abajo", "Down", o);
		
		aut.addTransicion(o, "izquierda", 
				"Left", aut.getEstadoByName("menuIr"));
		
		aut.addTransicion(o, "derecha", 
				"Right", aut.getEstadoManual());
		
		aut.addTransicion(o, "aceptar", 
				"Return", aut.getEstadoManual());
		
		aut.addTransicion(o, "entrar", 
				"Right", aut.getEstadoManual());
		
		aut.addTransicion(o, "cancelar", "Escape", i);
		aut.addTransicion(o, "continuar", "", i);
		
		aut.addTransicion(o, "cancelar", "Escape",i);
	}
	
	public void rellenarMenuMensaje(Automata aut) {
		Estado o = aut.getEstadoByName("menuMensaje");
		Estado i = aut.getEstadoInicial();
		Estado e = aut.getEstadoEspera();
		
		aut.addTransicion(o, "nuevo mensaje", "n", e);
		aut.addTransicion(o, "responder", "r", e);
		aut.addTransicion(o, "responder a todos", "p", e);
		aut.addTransicion(o, "responder a la lista", 
				"Escape,Control_L+Shift_L+L", e);
		aut.addTransicion(o, "reenviar", "v,Return", e);
		
		Estado adjuntos = new Estado("menuMensaje-Adjuntos");
		aut.addTransicion(o, "adjuntos","d",adjuntos);
		rellenarMenuMensajeAdjuntos(aut);
		
		Estado rc = new Estado("menuMensaje-ReenviarComo");
		aut.addTransicion(o, "reenviar como", "v,v,Right", rc);
		rellenarMenuMensajeReenviarComo(aut);
		
		aut.addTransicion(o, "editar mensaje como nuevo", "e", e);
		aut.addTransicion(o, "abrir mensaje", "a,Return", e);
		aut.addTransicion(o, "abrir en la conversacion", "b", e);
		
		Estado etiquetar = new Estado("menuMensaje-Etiquetar");
		aut.addTransicion(o, "etiquetar", "u", etiquetar);
		rellenarMenuMensajeEtiquetar(aut);
		
		Estado marcar = new Estado("menuMensaje-Marcar");
		aut.addTransicion(o, "marcar", "c,Right", marcar);
		rellenarMenuMensajeMarcar(aut);
		
		aut.addTransicion(o, "archivar", "a,a,Return", e);
		
		Estado mover = new Estado("menuMensaje-MoverA");
		aut.addTransicion(o, "mover a", "m", mover);
		rellenarMenuMensajeMoverA(aut);
		
		Estado copiar = new Estado("menuMensaje-CopiarA");
		aut.addTransicion(o, "copiar a", "c", copiar);
		rellenarMenuMensajeCopiarA(aut);
		
		aut.addTransicion(o, "mover de nuevo", "d", i);
		aut.addTransicion(o, "crear filtro a partir del mensaje", 
				"a,a,a,Return", e);
		
		aut.addTransicion(o, "ignorar conversacion", "i", i);
		aut.addTransicion(o, "ignorar subconversacion", "s", i);
		aut.addTransicion(o, "observar conversacion", "o", i);

			
		aut.addTransicion(o, "cancelar", "Escape", i);
	}
	
	public void rellenarMenuMensajeAdjuntosDentro(Automata aut){
		Estado o = aut.getEstadoByName("menuMensaje-Adjuntos-Dentro");
		Estado i = aut.getEstadoInicial();
		Estado e = aut.getEstadoEspera();

		aut.addTransicion(o, "abrir", "b",e);
		aut.addTransicion(o, "guardar como", "a",e);
		aut.addTransicion(o, "separar adjuntos", "r",e);
		aut.addTransicion(o, "eliminar", "d",e);
		aut.addTransicion(o, "atras",
				"Left", aut.getEstadoByName("menuMensaje-Adjuntos"));
		
		aut.addTransicion(o, "cancelar", "Escape",i);	
	}
	
	public void rellenarMenuMensajeAdjuntos(Automata aut){
		Estado o = aut.getEstadoByName("menuMensaje-Adjuntos");
		Estado i = aut.getEstadoInicial();
		
		Estado dentro = new Estado("menuMensaje-Adjuntos-Dentro");
		aut.addTransicion(o, "cero","0,Right", dentro);
		aut.addTransicion(o, "uno","1,Right", dentro);
		aut.addTransicion(o, "dos", "2,Right", dentro);
		aut.addTransicion(o, "tres", "3,Right",  dentro);
		aut.addTransicion(o, "cuatro", "4,Right", dentro);
		aut.addTransicion(o, "cinco", "5,Right", dentro);
		aut.addTransicion(o, "seis", "6,Right",  dentro);
		aut.addTransicion(o, "siete", "7,Right",  dentro);
		aut.addTransicion(o, "ocho", "8,Right",  dentro);
		aut.addTransicion(o, "nueve", "9,Right",  dentro);
		rellenarMenuMensajeAdjuntosDentro(aut);
		
		aut.addTransicion(o, "abrir todo", "o", i);
		aut.addTransicion(o, "guardar todo", "g",  i);		
		aut.addTransicion(o, "separar todos los adjuntos", 
				"d, Return",  i);		
		aut.addTransicion(o, "cero", "d, d, Return", i); 
		
		aut.addTransicion(o, "arriba", "Up", o);
		aut.addTransicion(o, "abajo", "Down", o);
		aut.addTransicion(o, "entrar", "Right", aut.getEstadoManual());
		aut.addTransicion(o, "derecha", "Right", aut.getEstadoManual());
		aut.addTransicion(o, "izquierda", "Left", aut.getEstadoManual());
		aut.addTransicion(o, "atras", 
				"Left", aut.getEstadoByName("menuArchivo"));
		
		aut.addTransicion(o, "cancelar", "Escape",i);
	}
	
	public void rellenarMenuMensajeReenviarComo(Automata aut){
		Estado o = aut.getEstadoByName("menuMensaje-ReenviarComo");
		Estado e = aut.getEstadoEspera();
	
		aut.addTransicion(o, "incorporado", "i", e);
		aut.addTransicion(o, "adjunto", "a", e);
			
		aut.addTransicion(o, "cancelar", "Escape", e);
	}
	
	public void rellenarMenuMensajeEtiquetar(Automata aut){
		Estado o = aut.getEstadoByName("menuMensaje-Etiquetar");
		Estado i = aut.getEstadoInicial();
		
		aut.addTransicion(o, "nueva etiqueta", "n", i);
		aut.addTransicion(o, "administrar etiquetas", "m", i);
		aut.addTransicion(o, "eliminar todas las etiquetas", "0", i);
		aut.addTransicion(o, "cero", "0", i);
		aut.addTransicion(o, "uno", "1", i);
		aut.addTransicion(o, "dos", "2", i);
		aut.addTransicion(o, "tres", "3", i);
		aut.addTransicion(o, "cuatro", "4", i);
		aut.addTransicion(o, "cinco", "5", i);
		aut.addTransicion(o, "seis", "6", i);
		aut.addTransicion(o, "siete", "7", i);
		aut.addTransicion(o, "ocho", "8", i);
		aut.addTransicion(o, "nueve", "9", i);
		aut.addTransicion(o, "arriba", "Up", o);
		aut.addTransicion(o, "abajo", "Down", o);
		aut.addTransicion(o, "aceptar", "Return", o);
		
		aut.addTransicion(o, "cancelar", "Escape", i);
	}
	
	public void rellenarMenuMensajeMarcar(Automata aut){
		Estado o = aut.getEstadoByName("menuMensaje-Marcar");
		Estado i = aut.getEstadoInicial();
		Estado e = aut.getEstadoEspera();
	
		aut.addTransicion(o, "como leidos", "l", i);
		aut.addTransicion(o, "como no leido", "n", i);
		aut.addTransicion(o, "conversacion como leida", "c,Return", i);
		aut.addTransicion(o, "como leidos por fecha", "d", e);
		aut.addTransicion(o, "todos leidos", "t", i);
		aut.addTransicion(o, "a~nadir estrella", "s,Return", i);
		aut.addTransicion(o, "como correo no deseado", "s,s,Return", i);
		aut.addTransicion(o, "como correo legitimo", "m", i);
		aut.addTransicion(o, "ejecutar controles de correo no deseado", "c,c,Return", i);
		
		aut.addTransicion(o, "cancelar", "Escape", i);
	}
	
	public void rellenarMenuMensajeMoverA(Automata aut){
		Estado o = aut.getEstadoByName("menuMensaje-MoverA");
		Estado i = aut.getEstadoInicial();
		
		aut.addTransicion(o, "reciente", "p",i);
		aut.addTransicion(o, "arriba", "Up", o);
		aut.addTransicion(o, "abajo", "Down", o);
		aut.addTransicion(o, "izquierda", "Left", aut.getEstadoByName("menuMensaje"));
		aut.addTransicion(o, "atras", "Left", aut.getEstadoByName("menuMensaje"));
		aut.addTransicion(o, "derecha", "Right", aut.getEstadoManual());
		aut.addTransicion(o, "aceptar", "Return", aut.getEstadoManual());
		aut.addTransicion(o, "entrar", "Right", aut.getEstadoManual());
		aut.addTransicion(o, "cancelar", "Escape", i);
		aut.addTransicion(o, "continuar", "", i);
	}
	
	public void rellenarMenuMensajeCopiarA(Automata aut){
		Estado o = aut.getEstadoByName("menuMensaje-CopiarA");
		Estado i = aut.getEstadoInicial();
		
		aut.addTransicion(o, "reciente", "p",i);
		aut.addTransicion(o, "arriba", "Up", o);
		aut.addTransicion(o, "abajo", "Down", o);
		aut.addTransicion(o, "izquierda", "Left", aut.getEstadoByName("menuMensaje"));
		aut.addTransicion(o, "atras", "Left", aut.getEstadoByName("menuMensaje"));
		aut.addTransicion(o, "derecha", "Right", aut.getEstadoManual());
		aut.addTransicion(o, "aceptar", "Return", aut.getEstadoManual());
		aut.addTransicion(o, "entrar", "Right", aut.getEstadoManual());
		aut.addTransicion(o, "cancelar", "Escape", i);
		aut.addTransicion(o, "continuar", "", i);
	}
	
	public void rellenarMenuHerramientas(Automata aut){
		Estado o = aut.getEstadoByName("menuHerramientas");
		Estado i = aut.getEstadoInicial();
		Estado e = aut.getEstadoEspera();
		
		aut.addTransicion(o, "libreta de direcciones", "l", aut.getEstadoLibretaDirecciones());
		aut.addTransicion(o, "archivos guardados", "h,Return", e);
		aut.addTransicion(o, "complementos", "m", e);
		aut.addTransicion(o, "administrador de actividad", "a", e);
		
		aut.addTransicion(o, "estado de chat", 
				"c,Right", aut.getEstadoManual());
		
		aut.addTransicion(o, "unirse al chat", "u,Return", e);
		aut.addTransicion(o, "filtros de mensajes", "f", e);
		aut.addTransicion(o, "ejecutar filtros en la carpeta", "r", e);
		aut.addTransicion(o, "ejecutar filtros en el mensaje", 
				"u,u,Return", e);
		aut.addTransicion(o, "ejecutar controles de correo no deseado", 
				"c,c,Return", i);
		aut.addTransicion(o, "eliminar mensajes marcados como no deseados", 
				"e,Return", i);
		aut.addTransicion(o, "importar", "i", e);
		aut.addTransicion(o, "consola de errores", "e,e,Return", e);
		aut.addTransicion(o, "limpiar historial reciente", 
				"h,h,Return", e);
	}

	
	public void rellenarModoManual(Automata aut){
		Estado o = aut.getEstadoManual();
		Estado i = aut.getEstadoInicial();
		
		aut.addTransicion(o, "arriba", "Up", o);
		aut.addTransicion(o, "abajo", "Down", o);
		aut.addTransicion(o, "izquierda", "Left", o);
		aut.addTransicion(o, "derecha", "Right", o);
		aut.addTransicion(o, "aceptar", "Return", o);
		aut.addTransicion(o, "entrar", "Right", o);
		aut.addTransicion(o, "cancelar", "Escape", o);
		aut.addTransicion(o, "continuar", "", i);
	}
	
}
